/*
    CalcH1Symplectic : Calculates the 1st (co)homology group of Sp(2g,Z/LZ) acting on the
                       symplectic Lie algebra over Z/(p^k)Z via the adjoint representation

    Copyright 2009 Andrew Putman.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include<vector>
#include<iostream>
#include "Matrix.h"
#include "Group.h"
#include "GroupRep.h"
#include "SymplecticGroup.h"

int main(void)
{
	int g,L,p,k,x;

	cout << "This program calculates the dimension of the 1st (co)homology group of Sp(2g,Z/LZ) acting on the" << endl;
	cout << "symplectic Lie algebra over Z/(p^k)Z via the adjoint representation, where p^k divides L." << endl << endl;

	cout << "Genus g : ";
	cin >> g;
	
	cout << "Level L : ";
	cin >> L;

	cout << "Prime p : ";
	cin >> p;

	cout << "Power k : ";
	cin >> k;

	cout << "Coefficient are (1) Adjoint rep  (2) Dual of Adjoint rep (i.e. calculate homology) : ";
	cin >> x;

	cout << endl;

	GroupRep SpAdj = SymplecticAdj(g,L,p,k);

	if (x == 1)
	{}
	else if (x == 2)
	{
		SpAdj = Dual(SpAdj);
	}
	else{
		cout << "Error!" << endl;
		return(0);
	}

	SpAdj.CalcH1(1,1);
	
	return(0);
}
