/*
    Symplectic Group Classes (headers) : part of CalcH1Symplectic

    Copyright 2009 Andrew Putman.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include<vector>
#include "Matrix.h"
#include "Group.h"
#include "GroupRep.h"

#ifndef __SYMPLECTICGROUP

#define __SYMPLECTICGROUP

using namespace std;

/*****************************************************************************
 *	SymplecticH(g,L,p,k) : Returns Sp_{2g}(Z/LZ) with the standard rep over p^k.  Here p^k must divide L.
 *****************************************************************************/
GroupRep SymplecticH(CounterType g, CounterType L, CounterType p, CounterType k);

/*****************************************************************************
 *	SymplecticAdj(g,L,p,k) : Returns Sp_{2g}(Z/LZ) with the adjoint rep over p^k.  Here p^k must divide L.
 *****************************************************************************/
GroupRep SymplecticAdj(CounterType g, CounterType L, CounterType p, CounterType k);

#endif
